For the complete documentation index, see llms.txt. This page is also available as Markdown.

Batch Screening

Screen large batches of molecules using our high-throughput retrosynthesis

A high-throughput screening campaign for large-scale chemical libraries can be achieved through submitting batches of Retrosynthesis jobs with shared parameters. Pending AI offers batch sizes of up to 00 jobs which can be created and then appended to with additional API requests. Batch progress can be tracked with live updates to the number of completed jobs and a high-level screening overview can be retrieved. Batch synthesis jobs impact the overall queue size for a given engine. Larger batches may lead to a longer wait time for it to complete. Additional metadata data can also be added to the batch submission to help distinguish results beyond an arbitrary batch id field. See here for more information on our Retrosynthesis capability.

Retrieve a Batch

get

Retrieve a Batch resource by its ID. Additional object metadata and shared Job parameters are included. Status and results are not included; use the dedicated routes for those operations.

Authorizations
OAuth2authorizationCodeRequired

Pending AI OAuth2 authentication.

Authorization URL: Token URL: Refresh URL:
Path parameters
batch_idstring · max: 128Required

Unique identifier for a Batch object. The IDs for objects are used to perform different operations.

Example: bat_32ALvrkANBUzVixmK2J2BrApeycPattern: ^[A-Za-z0-9_-]+$
Responses
404

Resource not found

application/json
nullOptional
get/batches/{batch_id}
GET /retro/v2/batches/{batch_id} HTTP/1.1
Host: api.pending.ai
Authorization: Bearer YOUR_OAUTH2_TOKEN
Accept: */*

No content

Update a Batch

put

Update a Batch and submit extra retrosynthesis Job resources. The number of jobs must not exceed the batch size limit of 100000. SMILES structures are not checked for duplicates against existing jobs in the batch, so care must be taken to avoid adding the same molecule multiple times.

Authorizations
OAuth2authorizationCodeRequired

Pending AI OAuth2 authentication.

Authorization URL: Token URL: Refresh URL:
Path parameters
batch_idstring · max: 128Required

Unique identifier for a Batch object. The IDs for objects are used to perform different operations.

Example: bat_32ALvrkANBUzVixmK2J2BrApeycPattern: ^[A-Za-z0-9_-]+$
Body

Request body for updating a Batch.

smilesstring[] · min: 1 · max: 100000Required

List of SMILES structures representing molecules to be submitted for retrosynthesis. Each query structure shares the same parameters defined for the batch. Duplicates and empty structures are removed.

Example: ["CC(=O)OCC","CCN(CC)CC"]
Responses
404

Resource not found

application/json
nullOptional
put/batches/{batch_id}
PUT /retro/v2/batches/{batch_id} HTTP/1.1
Host: api.pending.ai
Authorization: Bearer YOUR_OAUTH2_TOKEN
Content-Type: application/json
Accept: */*
Content-Length: 36

{
  "smiles": [
    "CC(=O)OCC",
    "CCN(CC)CC"
  ]
}

No content

Delete a Batch

delete

Delete a Batch and each attached retrosynthesis Job resource. All remaining queued jobs are cancelled even if the batch is currently being processed. The customer metered usage is updated to reflect any incomplete jobs.

Note that the operation is non-reversible and all resources are no longer accessible after deletion.

Authorizations
OAuth2authorizationCodeRequired

Pending AI OAuth2 authentication.

Authorization URL: Token URL: Refresh URL:
Path parameters
batch_idstring · max: 128Required

Unique identifier for a Batch object. The IDs for objects are used to perform different operations.

Example: bat_32ALvrkANBUzVixmK2J2BrApeycPattern: ^[A-Za-z0-9_-]+$
Responses
404

Resource not found

application/json
nullOptional
delete/batches/{batch_id}
DELETE /retro/v2/batches/{batch_id} HTTP/1.1
Host: api.pending.ai
Authorization: Bearer YOUR_OAUTH2_TOKEN
Accept: */*

No content

Retrieve a Batch status

get

Retrieve the current status of a Batch. The status relies on the individual status of all Job resources making it a computationally expensive operation. Poll the route with spaced requests to reduce the load on the server.

Authorizations
OAuth2authorizationCodeRequired

Pending AI OAuth2 authentication.

Authorization URL: Token URL: Refresh URL:
Path parameters
batch_idstring · max: 128Required

Unique identifier for a Batch object. The IDs for objects are used to perform different operations.

Example: bat_32ALvrkANBUzVixmK2J2BrApeycPattern: ^[A-Za-z0-9_-]+$
Responses
404

Resource not found

application/json
nullOptional
get/batches/{batch_id}/status
GET /retro/v2/batches/{batch_id}/status HTTP/1.1
Host: api.pending.ai
Authorization: Bearer YOUR_OAUTH2_TOKEN
Accept: */*

No content

Retrieve a Batch result

get

Retrieve the collection of results from all Job resources for the Batch. The list contains each job ID to use for retrieving synthetic routes and whether a query molecule was synthesizable. Incomplete jobs are marked as such.

Authorizations
OAuth2authorizationCodeRequired

Pending AI OAuth2 authentication.

Authorization URL: Token URL: Refresh URL:
Path parameters
batch_idstring · max: 128Required

Unique identifier for a Batch object. The IDs for objects are used to perform different operations.

Example: bat_32ALvrkANBUzVixmK2J2BrApeycPattern: ^[A-Za-z0-9_-]+$
Header parameters
accept-encodingany of · nullableOptional

Providing a value for the header will request that the response be converted into the specified format. If omitted, the response will be in the default JSON format. Most client libraries can automatically handle various compression communication formats.

stringOptional
or
string[]Optional
Responses
404

Resource not found

application/json
nullOptional
get/batches/{batch_id}/result
GET /retro/v2/batches/{batch_id}/result HTTP/1.1
Host: api.pending.ai
Authorization: Bearer YOUR_OAUTH2_TOKEN
Accept: */*

No content

List Batches

get

Retrieve a list of Batch resources using cursor-based pagination. See the returned data field for more information about the Batch resources. Use additional metadata and links fields to navigate the paginated resources.

Authorizations
OAuth2authorizationCodeRequired

Pending AI OAuth2 authentication.

Authorization URL: Token URL: Refresh URL:
Query parameters
afterstring · nullableOptional

An optional cursor used to indicate the item after which results should be returned. When provided, results that come after the specified cursor are returned. Cannot be used together with the before parameter.

        Note that results are returned in descending order so the
        `after` cursor returns older items that appear in pages that
        are *after* the current page.
beforestring · nullableOptional

An optional cursor used to indicate the item before which results should be returned. When provided, results that come before the specified cursor are returned. Cannot be used together with the after parameter.

        Note that results are returned in descending order so the
        `before` cursor returns newer items that appear in pages
        that are *before* the current page.
limitinteger · min: 1 · max: 100Optional

The maximum number of results to return for a single page of items. The value can adversely affect offset-based pagination when using the page parameter. Fewer results can be returned than the value specified.

Default: 25
Header parameters
accept-encodingany of · nullableOptional

Providing a value for the header will request that the response be converted into the specified format. If omitted, the response will be in the default JSON format. Most client libraries can automatically handle various compression communication formats.

stringOptional
or
string[]Optional
Responses
400

Invalid request parameters

application/json
nullOptional
get/batches
GET /retro/v2/batches HTTP/1.1
Host: api.pending.ai
Authorization: Bearer YOUR_OAUTH2_TOKEN
Accept: */*

No content

Create a Batch

post

Create a new Batch resource to manage a collection of retrosynthesis Job resources. Individual jobs are provided as a collection of SMILES structures and share a set of parameters.

  • Provide additional metadata to tag and identify the batch.

  • The batch size limit is 100000 jobs; for larger batches, split query molecules into manageable batches or update an initial Batch resource after creation.

Authorizations
OAuth2authorizationCodeRequired

Pending AI OAuth2 authentication.

Authorization URL: Token URL: Refresh URL:
Body

Request body for creating a new Batch.

namestring · max: 512 · nullableOptional

Name of the resource. The name is a human-readable identifier and is not required to be unique. The value can be used for display purposes.

Example: Resource APattern: ^.*\S.*$
descriptionstring · max: 2048 · nullableOptional

Description for a batch. Any text is allowed to provide additional context but must contain at least one non-whitespace character.

Example: Screening of targets for inhibitor 42.Pattern: ^.*\S.*$
filenamestring · max: 2048 · nullableOptional

Filename used for when a batch is submitted via file. This helps identify the batch and provides context for its retrosynthesis jobs.

Example: experiment_042_smiPattern: ^[^/\\<>:"|?*]+$
smilesstring[] · min: 1 · max: 100000Required

List of SMILES structures representing molecules to be submitted for retrosynthesis. Each query structure shares the same parameters defined for the batch. Duplicates and empty structures are removed.

Example: ["CC(=O)OCC","CCN(CC)CC"]
Responses
400

Invalid request parameters

application/json
nullOptional
post/batches
POST /retro/v2/batches HTTP/1.1
Host: api.pending.ai
Authorization: Bearer YOUR_OAUTH2_TOKEN
Content-Type: application/json
Accept: */*
Content-Length: 367

{
  "name": "Resource A",
  "description": "Screening of targets for inhibitor 42.",
  "filename": "experiment_042_smi",
  "smiles": [
    "CC(=O)OCC",
    "CCN(CC)CC"
  ],
  "parameters": {
    "retrosynthesis_engine": "eng_66efa389ba40f2769863c6fc3b598fc2e367bebbd214a6a3678492fd",
    "building_block_libraries": [
      "zinc"
    ],
    "number_of_routes": 1,
    "processing_time": 60,
    "reaction_limit": 1,
    "building_block_limit": 1
  }
}

No content

Last updated

Was this helpful?